--[[
  This source file is part of TINT.
  Copyright (C) 2010 Kyzentun.

  TINT is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as
  published by the Free Software Foundation, either version 2 of the
  License, or (at your option) any later version.

  TINT is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of both the GNU General Public
  License and the GNU General Public License along with
  TINT.  If not, see <http://www.gnu.org/licenses/>.
]]

function c_init()
  con_player_init()
  tint.setidleproc(c_on_planet)
end

function con_player_init()
  print("Creating player")
  print("Enter name.")
  player= {credits= 100, name= io.read("*line"), ship= {cargo_space= 100, cargos= {},
  fuel= 4, max_fuel= 20},
  cur_planet= "Klyztam"
  }
end

function c_on_planet()
  print(player.cur_planet)
  cp= planets[player.cur_planet]
  print(cp.desc .. "\n")
  plc= cp.commodities
  if(plc) then
    print("Commodities market:")
    print("Name: price | amount in hold")
    for name, value in pairs(plc) do
      local pa= 0
      if(player.ship.cargos[name]) then
        pa= player.ship.cargos[name].amount
      end
      print(name .. ":  " .. value.price .. " | " .. pa)
    end
  else
    print("No commodities here.")
  end
  print("\nNearby planets:")
  for name, value in pairs(cp.connections) do
    print(name)
  end
  print("\nYour action?")
  act= io.read("*line")
  if(act == "quit") then
    tint.clearidleproc()
  elseif(string.sub(act, 1, 1) == "t") then
    toss, toss2= string.find(act, "%w*")
    c_ftravel(string.sub(act, toss2+2))
  elseif(string.sub(act, 1, 1) == "b") then
    if(plc) then
      toss, toss2= string.find(act, "%w*")
      c_fbuy(string.sub(act, toss2+2))
    else
      print("No commodities here.")
    end
  elseif(string.sub(act, 1, 1) == "s") then
    if(plc) then
      toss, toss2= string.find(act, "%w*")
      c_fsell(string.sub(act, toss2+2))
    else
      print("No commodities here.")
    end
  elseif(string.sub(act, 1, 3) == "ref") then
    toss, toss2= string.find(act, "%w*")
    c_frefuel(string.sub(act, toss2+2))
  elseif(string.sub(act, 1, 3) == "rep") then
    c_freport()
  end
end

function c_ftravel(extra)
  if(extra == "" or extra == nil) then
    print("Destination?")
    extra= io.read("*line")
  end
  if(cp.connections[extra]) then
    if(player.ship.fuel > 0) then
      player.cur_planet= extra
      player.ship.fuel= player.ship.fuel - 1
    else
      print("You have no fuel!")
      io.read("*line")
    end
  else
    print("Your hyperdrive has overloaded!")
    tint.clearidleproc()
  end
end

function c_frefuel(extra)
  if(extra == "" or extra == nil) then
    print("How many jumps of fuel?")
    rn= tonumber(io.read("*line"))
  else
    toss, toss2= string.find(extra, "%d*")
    rn= tonumber(string.sub(extra, toss, toss2))
  end
  if(rn * 100 > player.credits) then
    rn= math.floor(player.credits / 100)
  end
  toss, toss2= string.find(extra, "%w*")
  extra= string.sub(extra, toss2+2)
  if(extra == "") then
    print("Confirm:  Refuel for " .. rn .. " jumps for " .. rn * 100 .. " credits.")
    extra= io.read("*line")
  end
  if(string.sub(extra, 1, 1) == "y") then
    player.ship.fuel= player.ship.fuel + rn
    player.credits= player.credits - (rn * 100)
  else
    print("Nevermind then.")
  end
  print("You have " .. player.ship.fuel .. " jumps of fuel.")
end

function c_fbuy(extra)
  toss, toss2= string.find(extra, "%w*")
  com= string.sub(extra, toss, toss2)
  extra= string.sub(extra, toss2+2)
  if(com == "") then
    print("Buy what?")
    com= io.read("*line")
  end
  if(plc[com]) then
    toss, toss2= string.find(extra, "%w*")
    ba= string.sub(extra, toss, toss2)
    extra= string.sub(extra, toss2+2)
    if(ba == "") then
      print("How much?")
      ba= io.read("*line")
    end
    ba= tonumber(ba)
    if(ba > player.ship.cargo_space) then
      ba= player.ship.cargo_space
    end
    if(ba * plc[com].price > player.credits) then
      ba= math.floor(player.credits / plc[com].price)
    end
    toss, toss2= string.find(extra, "%w*")
    act= string.sub(extra, toss, toss2)
    if(act == "") then
      print("Confirm:  Buy " .. ba .. " tons of " .. com .. " for " .. ba * plc[com].price)
      act= io.read("*line")
    end
    if(string.sub(act, 1, 1) == "y") then
      fbuy(player, com, ba, plc[com].price)
    else
      print("Nevermind then.")
    end
  else
    print("We don't sell that here.")
  end
end

function c_fsell(extra)
  toss, toss2= string.find(extra, "%w*")
  com= string.sub(extra, toss, toss2)
  extra= string.sub(extra, toss2+2)
  if(com == "") then
    print("Sell what?")
    com= io.read("*line")
  end
  if(player.ship.cargos[com]) then
    if(plc[com]) then
      toss, toss2= string.find(extra, "%w*")
      sa= string.sub(extra, toss, toss2)
      extra= string.sub(extra, toss2+2)
      if(sa == "") then
        print("How much?")
        sa= io.read("*line")
      end
      sa= tonumber(sa)
      if(sa > player.ship.cargos[com].amount) then
        sa= player.ship.cargos[com].amount
      end
      if(extra == "") then
        print("Confirm:  Sell " .. sa .. " tons of " .. com .. " for " .. sa * plc[com].price)
        extra= io.read("*line")
      end
      if(string.sub(extra, 1, 1) == "y") then
        fsell(player, com, sa, plc[com].price)
      else
        print("Nevermind then.")
      end
    else
      print("We won't buy that here.")
    end
  else
    print("You don't have any.")
  end
end

function c_freport()
    print("\nName:  " .. player.name .. "\nCredits:  " .. player.credits .. "\nFuel:  " .. player.ship.fuel)
    print("Cargo space:  " .. player.ship.cargo_space)
    for com, amount in pairs(player.ship.cargos) do
      print(com .. " | " .. amount.amount)
    end
    io.read("*line")
end
